<?php
/*
Plugin Name: Those Were The Days...
Plugin URI: http://www.bochgoch.com/?p=wp
Description: This is a featured posts plugin it provides configurable links to posts that you want to highlight on your blog.
Version: 0.2
Author: bochgoch
Author URI: http://www.bochgoch.com
*/

/*  Copyright 2007  Martin Ford  (email : wordpress@bochgoch.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

add_option('thosewerethedays_numberOfPosts', '5', 'The number of featured posts generated by the Those Were The Days plugin', 'yes');
add_option('thosewerethedays_orderBy', 'rand()', 'The selection method for the related posts generated by the Those Were The Days plugin', 'yes');
add_option('thosewerethedays_showSentence', 'Y', 'Flag to select if a sentence of the post will be shown after the link by the Those Were The Days plugin', 'yes');
add_option('thosewerethedays_showHeading', 'Featured Posts...', 'Heading shown above the Those Were The Days plugin links', 'yes');
add_option('thosewerethedays_showAuthor', 'Y', 'Flag to select if the post author is shown the for Those Were The Days plugin links', 'yes');
add_option('thosewerethedays_showDate', 'Y', 'Flag to select if the post date is shown the for Those Were The Days plugin links', 'yes');
add_option('thosewerethedays_deselectPosts', 'N', 'Flag to select if posts are only featured once by the Those Were The Days plugin links', 'yes');
add_option('thosewerethedays_refreshFreq', 'daily', 'Value to specify how regularly Those Were The Days plugin links are refreshed', 'yes');

function those_were_the_days() {
	global $wpdb;
 
	$numPosts = get_option('thosewerethedays_numberOfPosts');
	$orderBy = get_option('thosewerethedays_orderBy');
	$showSentence = get_option('thosewerethedays_showSentence');
	$Heading = get_option('thosewerethedays_showHeading');
	$showAuthor = get_option('thosewerethedays_showAuthor');
	$showDate = get_option('thosewerethedays_showDate');

	$SQLPosts = "";
	$postsIncluded = $wpdb->get_results("SELECT DISTINCT t1.post_id FROM ".$wpdb->prefix."bochgoch_twtd_options t1 WHERE t1.featured = 1");
	if (count($postsIncluded) > 0)
  {
  	foreach ($postsIncluded as $postIncluded) {
  	  $SQLPosts .= $postIncluded->post_id.',';
  	}
  	$SQLPosts = " t1.ID IN (".substr($SQLPosts,0,strlen($SQLPosts)-1).") ";
	}
	else { _e('TWTD error occurred!'); return; /* no featured posts so bug outa here... */ }

	$thoseWereTheDays = $wpdb->get_results("SELECT t1.ID, t1.post_title, t1.post_date, t1.post_content, t3.display_name 
																					FROM $wpdb->posts t1, $wpdb->users t3 
																					WHERE t1.post_status = 'publish' 
																					AND t1.post_author = t3.ID AND (".$SQLPosts.") 
																					ORDER BY ".$orderBy." 
																					LIMIT ".$numPosts);

	if (count($thoseWereTheDays) > 0) {
  	$thoseWereTheDaysHTML = '<div id="thosewerethedays"><h2 class="widgettitle">'.$Heading.'</h2>';
    foreach ($thoseWereTheDays as $thoseWereTheDay) {
			$postSentence = '';
  	  if (substr(strtolower($showSentence),0,1) == 'y') {
  			$pieces = split("\. ?", $thoseWereTheDay->post_content);
    		if (strlen($pieces[0]) > 0) {
  				$postSentence = '<br />'.strip_tags($pieces[0]);
					if (strlen($postSentence) < 10) { $postSentence = ''; } //remove short sentences
  			} 
			}
    	$thoseWereTheDaysHTML .= '<p><a href="'.get_permalink($thoseWereTheDay->ID).'">'.$thoseWereTheDay->post_title.'</a>';
			if (substr(strtolower($showAuthor),0,1) == 'y') { $thoseWereTheDaysHTML .= ' by '.$thoseWereTheDay->display_name; }
			if (substr(strtolower($showDate),0,1) == 'y') { $thoseWereTheDaysHTML .= ' on '.date('F jS, Y',strtotime($thoseWereTheDay->post_date)); }
			$thoseWereTheDaysHTML .= $postSentence.'</p>';
    }
    $thoseWereTheDaysHTML .= '</div>';
	}	else {
    $thoseWereTheDaysHTML = '';
	}
  _e($thoseWereTheDaysHTML);
}

function those_were_the_days_css() {
	echo "
	<style type='text/css'>
	table.thosewerethedays {
	border-collapse:collapse
	}
  table.thosewerethedays tr td
	{
	border-width:1px 0;
	border-style:solid;
	border-color:gray;
	padding:3px 2px 3px 2px;
	}
	</style>
	";
}
//poke the css into the <head>
add_action('admin_head', 'those_were_the_days_css');

function twtd_plugin_selector() {
	global $wpdb;
	
	$numPosts = get_option('thosewerethedays_numberOfPosts');
	$orderBy = get_option('thosewerethedays_orderBy');
	$deselectPosts = get_option('thosewerethedays_deselectPosts');

  if (substr(strtolower($deselectPosts),0,1) == 'y') 
	{ $DELETEFromTable = $wpdb->get_results("DELETE FROM ".$wpdb->prefix."bochgoch_twtd_options WHERE featured = 1"); }
	
	$thoseWereTheDays = $wpdb->get_results("SELECT post_id FROM ".$wpdb->prefix."bochgoch_twtd_options t1, $wpdb->posts t2 WHERE cat_id IS NULL AND t1.post_id = t2.ID ORDER BY ".$orderBy." LIMIT ".$numPosts);
	if (count($thoseWereTheDays) > 0) {
    foreach ($thoseWereTheDays as $thoseWereTheDay) {
		   $thoseWereTheDaysUPDATE = $wpdb->get_results("UPDATE ".$wpdb->prefix."bochgoch_twtd_options SET featured = 1 WHERE post_id = ".$thoseWereTheDay->post_id ." AND cat_id IS NULL");
		}
	}	
}
add_action('twtd_plugin_selector_hook', 'twtd_plugin_selector');

function twtd_plugin_menu() {
	global $wpdb;

  $message = null;
  $message_updated = __("Those Were The Days Plugin Options Updated.");

  $wpdb->hide_errors();
  	$checkTableExists = $wpdb->get_results("SELECT COUNT(*) FROM ".$wpdb->prefix."bochgoch_twtd_options");
  	if (count($checkTableExists) != 1) {
    	$wpdb->get_results("CREATE TABLE ".$wpdb->prefix."bochgoch_twtd_options 
  	  ( 
    		id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, 
    		cat_id INT NULL,
    		post_id INT NULL,
				featured INT NULL
  		)
  		");  
  }
  $wpdb->show_errors();
  
  // update options
  if ($_POST['action'] && $_POST['action'] == 'twtd_update') {
  	$message = $message_updated;
		
  	update_option('thosewerethedays_numberOfPosts', $_POST['thosewerethedays_numberOfPosts']);
  	update_option('thosewerethedays_orderBy', $_POST['thosewerethedays_orderBy']);
  	update_option('thosewerethedays_showSentence', $_POST['thosewerethedays_showSentence']);
  	update_option('thosewerethedays_showHeading', $_POST['thosewerethedays_showHeading']);	
  	update_option('thosewerethedays_showAuthor', $_POST['thosewerethedays_showAuthor']);	
  	update_option('thosewerethedays_showDate', $_POST['thosewerethedays_showDate']);	
  	update_option('thosewerethedays_deselectPosts', $_POST['thosewerethedays_deselectPosts']);	
  	update_option('thosewerethedays_refreshFreq', $_POST['thosewerethedays_refreshFreq']);	

		// Selected Posts
	  $EMPTYTable = $wpdb->get_results("DELETE FROM ".$wpdb->prefix."bochgoch_twtd_options WHERE post_id IS NOT NULL");
		for ( $counter = 1; $counter <= $_POST['thosewerethedays_TotalPosts']; $counter += 1 )
		{
		 if ( $_POST['post'.$counter] != null) 
		 { $INSERTTable = $wpdb->get_results("INSERT INTO ".$wpdb->prefix."bochgoch_twtd_options VALUES (null,null,".$_POST['post'.$counter].",0)"); }
		}
		// Selected Categories
	  $EMPTYTable = $wpdb->get_results("DELETE FROM ".$wpdb->prefix."bochgoch_twtd_options WHERE cat_id IS NOT NULL");
		for ( $counter = 1; $counter <= $_POST['thosewerethedays_TotalCategories']; $counter += 1 )
		{
		 if ( $_POST['category'.$counter] != null) 
		 { 
		 	 $INSERTTable = $wpdb->get_results("INSERT INTO ".$wpdb->prefix."bochgoch_twtd_options SELECT null,".$_POST['category'.$counter].",t1.ID,0 from ".$wpdb->prefix."posts t1, ".$wpdb->prefix."post2cat t2 where t1.ID = t2.post_id and t2.category_id = ".$_POST['category'.$counter]); 
		 	 $INSERTTable2 = $wpdb->get_results("INSERT INTO ".$wpdb->prefix."bochgoch_twtd_options SELECT null,null,t1.ID,0 from ".$wpdb->prefix."posts t1, ".$wpdb->prefix."post2cat t2 where t1.ID = t2.post_id and t2.category_id = ".$_POST['category'.$counter]); 
		 }
		}
  	wp_cache_flush();
		
		//cron for scheduled refreshes of featured posts
  	require_once('admin.php');
		if (wp_next_scheduled('twtd_plugin_selector_hook') != false) { wp_clear_scheduled_hook('twtd_plugin_selector_hook'); }
  	wp_schedule_event(time(),$_POST['thosewerethedays_refreshFreq'],'twtd_plugin_selector_hook');
		
  }
  if ($message) : ?>
  <div id="message" class="updated fade"><p><?php echo $message; ?></p></div>
  <?php endif; ?>
  <div id="dropmessage" class="updated" style="display:none;"></div>
  <div class="wrap">
  <h2><?php _e('Those Were The Days Plugin Options'); ?></h2>
  <p><?php _e('With queries, questions or suggestions <a title="Bochgoch Home for Wordpress Plugins" href="http://www.bochgoch.com/?p=wp">Visit Bochgoch</a>.') ?></p>
  <form name="dofollow" action="" method="post">
  <table>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('The heading to display above the featured posts:')?></th>
  <td>
  <input size="80" name="thosewerethedays_showHeading" value="<?php echo stripcslashes(get_option('thosewerethedays_showHeading')); ?>"/>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('The number of featured posts to display:')?></th>
  <td>
  <input size="2" name="thosewerethedays_numberOfPosts" value="<?php echo stripcslashes(get_option('thosewerethedays_numberOfPosts')); ?>"/>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Ordering method for the displayed posts:')?></th>
  <td>
  <input type="radio" name="thosewerethedays_orderBy" value="rand()" <?php if (get_option('thosewerethedays_orderBy')=='rand()') echo "checked"; ?>> Random<br>
  <input type="radio" name="thosewerethedays_orderBy" value="post_date asc" <?php if (get_option('thosewerethedays_orderBy')=='post_date asc') echo "checked"; ?>> Date of post - ascending<br>
  <input type="radio" name="thosewerethedays_orderBy" value="post_date desc" <?php if (get_option('thosewerethedays_orderBy')=='post_date desc') echo "checked"; ?>> Date of post - descending<br>
  <input type="radio" name="thosewerethedays_orderBy" value="post_title asc" <?php if (get_option('thosewerethedays_orderBy')=='post_title asc') echo "checked"; ?>> Title of post - ascending<br>
  <input type="radio" name="thosewerethedays_orderBy" value="post_title desc" <?php if (get_option('thosewerethedays_orderBy')=='post_title desc') echo "checked"; ?>> Title of post - descending<br>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show the first sentence of linked posts:')?></th>
  <td>
  <input size="1" name="thosewerethedays_showSentence" value="<?php echo stripcslashes(get_option('thosewerethedays_showSentence')); ?>"/> (Y/N)
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show the name of the post author:')?></th>
  <td>
  <input size="1" name="thosewerethedays_showAuthor" value="<?php echo stripcslashes(get_option('thosewerethedays_showAuthor')); ?>"/> (Y/N)
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show the date that the post was made:')?></th>
  <td>
  <input size="1" name="thosewerethedays_showDate" value="<?php echo stripcslashes(get_option('thosewerethedays_showDate')); ?>"/> (Y/N)
  </td>
  </tr>

  <tr><th> <hr /> </th><td></td></tr>
<!-- Posts -->
	<tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Your Posts')?></th>
	<td>
	<table class="thosewerethedays">
<?php
	$orderBy = 't1.ID';
	$numPosts = '9999';
	$thoseWereTheDaysHTML = "";
	$counter = 1;
	
	$version = explode(".", get_bloginfo('version'));
	if ( $version[0] > 2 or ($version[0] == 2 and $version[1] >= 3) ) // version greater than 2.3
	{
	 $thoseWereTheDays = $wpdb->get_results("SELECT DISTINCT t1.ID, t1.post_title, t1.post_date, t1.post_content, t3.display_name FROM $wpdb->posts t1, $wpdb->term_taxonomy t2, $wpdb->term_relationships t4, $wpdb->users t3 WHERE t1.post_status = 'publish' AND t1.ID=t4.object_id AND t4.term_taxonomy_id = t2.term_taxonomy_id AND t2.taxonomy = 'category' AND t1.post_author = t3.ID ORDER BY ".$orderBy." LIMIT ".$numPosts);
	}
	else // pre 2.3
	{
	 $thoseWereTheDays = $wpdb->get_results("SELECT DISTINCT t1.ID, t1.post_title, t1.post_date, t1.post_content, t3.display_name FROM $wpdb->posts t1, $wpdb->post2cat t2, $wpdb->users t3 WHERE t1.ID=t2.post_id AND t1.post_status = 'publish' AND t1.post_author = t3.ID ORDER BY ".$orderBy." LIMIT ".$numPosts);
	}
	if (count($thoseWereTheDays) > 0) {
		echo '<tr><td colspan=4>Total Posts:<input size="2" readonly name="thosewerethedays_TotalPosts" value="'.count($thoseWereTheDays).'"/>&nbsp; Ticked posts will be included as featured.</td></tr>';
    foreach ($thoseWereTheDays as $thoseWereTheDay) {
			$postIncluded = $wpdb->get_results("SELECT id, featured FROM ".$wpdb->prefix."bochgoch_twtd_options WHERE post_id = ".$thoseWereTheDay->ID);
    	$thoseWereTheDaysHTML .= '<tr><td><input type="checkbox" name="post'.$counter.'" value="'.$thoseWereTheDay->ID.'"';
			if (count($postIncluded) > 0) {$thoseWereTheDaysHTML .= ' CHECKED >';} else {$thoseWereTheDaysHTML .= ' >';}
			$thoseWereTheDaysHTML .= $thoseWereTheDay->ID;
			$thoseWereTheDaysHTML .= '</td><td>';
			$thoseWereTheDaysHTML .= $thoseWereTheDay->post_title;
			$thoseWereTheDaysHTML .= '</td><td>';
			$thoseWereTheDaysHTML .= $thoseWereTheDay->category_id;
			$thoseWereTheDaysHTML .= '</td><td>';
			$thoseWereTheDaysHTML .= ' by '.$thoseWereTheDay->display_name;
			$thoseWereTheDaysHTML .= ' on '.date('F jS, Y',strtotime($thoseWereTheDay->post_date));
			$thoseWereTheDaysHTML .= '</td><td>';
			if ( count($postIncluded) > 0 ) {$thoseWereTheDaysHTML .= $postIncluded->featured;}
			$thoseWereTheDaysHTML .= '</td>';
			$thoseWereTheDaysHTML .= '</tr>';
			$counter += 1;
		}
	}
  _e($thoseWereTheDaysHTML);
?>
	</table>
	</td></tr>
	
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Deselect posts after they have been featured:')?></th>
  <td>
  <input size="1" name="thosewerethedays_deselectPosts" value="<?php echo stripcslashes(get_option('thosewerethedays_deselectPosts')); ?>"/> (Y/N)
  </td>
  </tr>

  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Featured posts refresh frequency:')?></th>
  <td>
<?php
	$schedules = wp_get_schedules();
	$thoseWereTheDaysHTML = "";
	foreach ($schedules as $schedule=>$period) {
			$thoseWereTheDaysHTML .= '<input type="radio" name="thosewerethedays_refreshFreq" value="'.$schedule.'"';
			if (get_option('thosewerethedays_refreshFreq')==$schedule) $thoseWereTheDaysHTML .= ' "checked" '; 
			$thoseWereTheDaysHTML .='> '.$period['display'].' ('.$period['interval'].' seconds)<br>';						
	}
  _e($thoseWereTheDaysHTML);
?>	
  </td>
  </tr>

  <tr><th> <hr /> </th><td></td></tr>
<!-- Categories -->	
	<tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Your Blog Categories')?></th>
	<td>
	<table class="thosewerethedays">
<?php
	$thoseWereTheDaysHTML = "";
	$counter = 1;
	//$thoseWereTheDays = $wpdb->get_results("SELECT t1.cat_id, t1.cat_name FROM $wpdb->categories t1");
	
	if ( $version[0] > 2 or ($version[0] == 2 and $version[1] >= 3) ) // version greater than 2.3
	{
	 $thoseWereTheDays = $wpdb->get_results("SELECT DISTINCT t2.term_id cat_id, t4.name cat_name FROM $wpdb->term_taxonomy t2, $wpdb->terms t4 WHERE t4.term_id = t2.term_id AND t2.taxonomy = 'category'");
	}
	else // pre 2.3
	{
	 $thoseWereTheDays = $wpdb->get_results("SELECT DISTINCT t1.cat_id, t1.cat_name FROM $wpdb->categories t1");
	}

	
	if (count($thoseWereTheDays) > 0) {
		echo '<tr><td colspan=3>Total Categories:<input size="2" readonly name="thosewerethedays_TotalCategories" value="'.count($thoseWereTheDays).'"/>Tick the categories you want include all posts from as featured.</td></tr>';
    foreach ($thoseWereTheDays as $thoseWereTheDay) {
			$categoryIncluded = $wpdb->get_results("SELECT t1.cat_id FROM ".$wpdb->prefix."bochgoch_twtd_options t1 WHERE t1.cat_id=".$thoseWereTheDay->cat_id);
    	$thoseWereTheDaysHTML .= '<tr><td><input type="checkbox" name="category'.$counter.'" value="'.$thoseWereTheDay->cat_id.'"';
			if (count($categoryIncluded) > 0) {$thoseWereTheDaysHTML .= ' CHECKED >';} else {$thoseWereTheDaysHTML .= ' >';}
			$thoseWereTheDaysHTML .= $thoseWereTheDay->cat_id;
			$thoseWereTheDaysHTML .= '</td><td>';
			$thoseWereTheDaysHTML .= $thoseWereTheDay->cat_name;
			$thoseWereTheDaysHTML .= '</td></tr>';
			$counter += 1;
		}
	}
  _e($thoseWereTheDaysHTML);
?>
	</table>
	</td></tr>
	
  </table>
  <p class="submit">
  <input type="hidden" name="action" value="twtd_update" /> 
  <input type="submit" name="Submit" value="<?php _e('Update Options')?> &raquo;" /> 
  </p>
  </form>
  </div>
  <?php
}

add_action('plugins_loaded', 'twtd_init');
function twtd_init() {
    if (!function_exists('register_sidebar_widget')) { return; }
    register_sidebar_widget('Those Were The Days', 'those_were_the_days'); 
}

function twtd_add_pages() {
    // Add a new menu under Options:
    add_options_page('Those Were The Days options', 'Those Were The Days', 8, 'those_were_the_days.php', 'twtd_plugin_menu');
}
add_action('admin_menu', 'twtd_add_pages');


function twtd_add_intervals() {
		// in addition to hourly and daily >>
		return array( 'hourly' => array('interval' => 3600, 'display' => 'Every Hour'),
		              '8daily' => array('interval' => 10800, 'display' => 'Eight times a day (3 hours)'),		
		              '4daily' => array('interval' => 21600, 'display' => 'Four times a day (6 hours)'),		
		              '2daily' => array('interval' => 43200, 'display' => 'Twice a day (12 hours)'),		
		              'daily' => array('interval' => 86400, 'display' => 'Once a day (24 hours)')		
		);
}
add_filter('cron_schedules','twtd_add_intervals');
?>
